diff -ruN ../nakedmudv2.7/src/olc2/protedit.c src/olc2/protedit.c
--- ../nakedmudv2.7/src/olc2/protedit.c	Wed Dec 31 17:00:00 1969
+++ src/olc2/protedit.c	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,132 @@
+//*****************************************************************************
+//
+// protedit.c
+//
+// protedit (prototype edit) handles the OLC editing of prototypes.
+//
+//*****************************************************************************
+
+#include "../mud.h"
+#include "../utils.h"
+#include "../prototype.h"
+#include "../socket.h"
+#include "../character.h"
+#include "../room.h"
+#include "../world.h"
+#include "olc.h"
+
+
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../editor/editor.h"
+#include "../scripts/scripts.h"
+#include "../scripts/script_editor.h"
+
+
+
+//*****************************************************************************
+// olc functions
+//*****************************************************************************
+#define PROTEDIT_PARENTS    1
+
+void protedit_menu(SOCKET_DATA *sock, PROTO_DATA *data) {
+  send_to_socket(sock,
+		 "{y[{c%s{y]\r\n"
+		 "{g1) parents : {c%s\r\n"
+		 "{g2) abstract: {c%s\r\n"
+		 "{g3) prototype code\r\n",
+		 protoGetKey(data), protoGetParents(data), 
+		 (protoIsAbstract(data) ? "yes" : "no"));
+  script_display(sock, protoGetScript(data), FALSE);
+}
+
+int protedit_chooser(SOCKET_DATA *sock, PROTO_DATA *data, const char *option) {
+  switch(toupper(*option)) {
+  case '1':
+    send_to_socket(sock, "Enter a comma-separated list of the parent prototypes: ");
+    return PROTEDIT_PARENTS;
+  case '2':
+    protoSetAbstract(data, (protoIsAbstract(data) + 1) % 2);
+    return MENU_NOCHOICE;
+  case '3':
+    socketStartEditor(sock, script_editor, protoGetScriptBuffer(data));
+    return MENU_NOCHOICE;
+  default:
+    return MENU_CHOICE_INVALID;
+  }
+}
+
+bool protedit_parser(SOCKET_DATA *sock, PROTO_DATA *data, int choice, 
+		     const char *arg) {
+  switch(choice) {
+  case PROTEDIT_PARENTS:
+    protoSetParents(data, arg);
+    return TRUE;
+  default:
+    return FALSE;
+  }
+}
+
+void save_mproto(PROTO_DATA *mproto) {
+  worldSaveType(gameworld, "mproto", protoGetKey(mproto));
+}
+
+void save_oproto(PROTO_DATA *oproto) {
+  worldSaveType(gameworld, "oproto", protoGetKey(oproto));
+}
+
+void save_rproto(PROTO_DATA *rproto) {
+  worldSaveType(gameworld, "rproto", protoGetKey(rproto));
+}
+
+void gen_cmd_protoedit(CHAR_DATA *ch, const char *type, const char *arg,
+		       void (* saver)(PROTO_DATA *)) {
+  ZONE_DATA    *zone = NULL;
+  PROTO_DATA  *proto = NULL;
+
+  // we need a key
+  if(!arg || !*arg)
+    send_to_char(ch, "What is the name of the %s you want to edit?\r\n", type);
+  else {
+    char locale[SMALL_BUFFER];
+    char   name[SMALL_BUFFER];
+    if(!parse_worldkey_relative(ch, arg, name, locale))
+      send_to_char(ch, "Which %s are you trying to edit?\r\n", type);
+    // make sure we can edit the zone
+    else if((zone = worldGetZone(gameworld, locale)) == NULL)
+      send_to_char(ch, "No such zone exists.\r\n");
+    else if(!canEditZone(zone, ch))
+      send_to_char(ch, "You are not authorized to edit that zone.\r\n");
+    else {
+      // try to pull up the prototype
+      proto = worldGetType(gameworld, type, get_fullkey(name, locale));
+      if(proto == NULL) {
+	proto = newProto();
+	protoSetAbstract(proto, TRUE);
+	protoSetScript(proto, 
+		       "# prototype code goes here\n"
+		       "# make sure to comment it with pounds (#)\n");
+	worldPutType(gameworld, type, get_fullkey(name, locale), proto);
+      }
+      
+      do_olc(charGetSocket(ch), protedit_menu, protedit_chooser,protedit_parser,
+ 	     protoCopy, protoCopyTo, deleteProto, saver, proto);
+    }
+  }
+}
+
+COMMAND(cmd_mpedit) {
+  gen_cmd_protoedit(ch, "mproto", arg, save_mproto);
+}
+
+COMMAND(cmd_opedit) {
+  gen_cmd_protoedit(ch, "oproto", arg, save_oproto);
+}
+
+COMMAND(cmd_rpedit) {
+  gen_cmd_protoedit(ch, "rproto", 
+		    (arg && *arg ? arg : roomGetClass(charGetRoom(ch))), 
+		    save_rproto);
+}
diff -ruN ../nakedmudv2.7/src/olc2/redit.c src/olc2/redit.c
--- ../nakedmudv2.7/src/olc2/redit.c	Sun Jul 31 17:13:51 2005
+++ src/olc2/redit.c	Fri Oct  7 14:15:55 2005
@@ -2,21 +2,26 @@
 //
 // redit.c
 //
-// redit (room edit) is a utility to allow builders to edit rooms within the
-// game. Contains the functions for editing datastructures specific to rooms
-// (rooms, exits, room resets).
+// When room prototypes became python scripts, The room OLC had to be rethought.
+// Ideally, all builders would have a basic grasp on python and thus would be
+// able to write scripts. Ideally. Sadly, I don't think this can be expected
+// out of most builders, and we still need some sort of non-scripting interface
+// for editing objs. So here it is...
 //
 //*****************************************************************************
 #include "../mud.h"
 #include "../utils.h"
 #include "../socket.h"
-#include "../character.h"
 #include "../world.h"
 #include "../zone.h"
 #include "../room.h"
+#include "../character.h"
+#include "../object.h"
 #include "../exit.h"
 #include "../room_reset.h"
-#include "../object.h"
+#include "../extra_descs.h"
+#include "../prototype.h"
+#include "../handler.h"
 
 #include "olc.h"
 #include "olc_submenus.h"
@@ -26,8 +31,9 @@
 //*****************************************************************************
 // mandatory modules
 //*****************************************************************************
-#include "../scripts/script.h"
 #include "../editor/editor.h"
+#include "../scripts/scripts.h"
+#include "../scripts/script_editor.h"
 
 
 
@@ -41,41 +47,82 @@
 
 
 //*****************************************************************************
-// functions for printing room reset data
+// room reset olc structs
 //*****************************************************************************
+typedef struct {
+  RESET_DATA *reset;
+  char      *locale;
+} RESET_OLC;
+
+RESET_OLC *newResetOLC(RESET_DATA *reset, const char *locale) {
+  RESET_OLC *data = malloc(sizeof(RESET_OLC));
+  data->reset  = reset;
+  data->locale = strdupsafe(locale);
+  return data;
+}
+
+void deleteResetOLC(RESET_OLC *data) {
+  if(data->locale) free(data->locale);
+  free(data);
+}
+
 
-// the resedit olc needs these declared
-void rrledit_menu(SOCKET_DATA *sock, LIST *list);
-int  rrledit_chooser(SOCKET_DATA *sock, LIST *list, const char *option);
-bool rrledit_parser(SOCKET_DATA *sock, LIST *list, int choice, const char *arg);
 
-const char *write_reset_arg(int type, const char *arg) {
+//*****************************************************************************
+// room reset list olc structs. Note these are different from RESET_LISTs. This
+// is for lists of in/on/then resets that are attached onto other resets.
+//*****************************************************************************
+typedef struct {
+  LIST *res_list;
+  char   *locale;
+} RESLIST_OLC;
+
+RESLIST_OLC *newReslistOLC(LIST *list, const char *locale) {
+  RESLIST_OLC *data = malloc(sizeof(RESLIST_OLC));
+  data->res_list    = list;
+  data->locale      = strdupsafe(locale);
+  return data;
+}
+
+void deleteReslistOLC(RESLIST_OLC *data) {
+  if(data->locale) free(data->locale);
+  free(data);
+}
+
+
+
+//*****************************************************************************
+// functions for printing room reset data
+//*****************************************************************************
+const char *write_reset_arg(int type, const char *arg, const char *locale) {
   static char buf[SMALL_BUFFER];
-  OBJ_DATA *obj  = worldGetObj(gameworld, atoi(arg));
-  CHAR_DATA *mob = worldGetMob(gameworld, atoi(arg));
-  int pos        = atoi(arg);
+  PROTO_DATA  *obj = 
+    worldGetType(gameworld, "oproto", get_fullkey_relative(arg, locale));
+  PROTO_DATA  *mob = 
+    worldGetType(gameworld, "mproto", get_fullkey_relative(arg, locale));
+  int pos          = atoi(arg);
   switch(type) { 
   case RESET_LOAD_OBJECT:
-    sprintf(buf, "load %s", (obj ? objGetName(obj) : "{RNOTHING{c"));
+    sprintf(buf, "load %s", (obj ? protoGetKey(obj) : "{RNOTHING{c"));
     break;
   case RESET_LOAD_MOBILE:
-    sprintf(buf, "load %s", (mob ? charGetName(mob) : "{RNOBODY{c"));
+    sprintf(buf, "load %s", (mob ? protoGetKey(mob) : "{RNOBODY{c"));
     break;
   case RESET_POSITION:
-    sprintf(buf, "change position to %s", 
+    sprintf(buf, "change position to %s",
 	    (pos < 0 || pos >= NUM_POSITIONS ? "{RNOTHING{c":posGetName(pos)));
     break;
   case RESET_FIND_MOBILE:
-    sprintf(buf, "find %s", (mob ? charGetName(mob) : "{RNOBODY{c"));
+    sprintf(buf, "find %s", (mob ? protoGetKey(mob) : "{RNOBODY{c"));
     break;
   case RESET_FIND_OBJECT:
-    sprintf(buf, "find %s", (obj ? objGetName(obj) : "{RNOTHING{c"));
+    sprintf(buf, "find %s", (obj ? protoGetKey(obj) : "{RNOTHING{c"));
     break;
   case RESET_PURGE_MOBILE:
-    sprintf(buf, "purge %s", (mob ? charGetName(mob) : "{RNOBODY{c"));
+    sprintf(buf, "purge %s", (mob ? protoGetKey(mob) : "{RNOBODY{c"));
     break;
   case RESET_PURGE_OBJECT:
-    sprintf(buf, "purge %s", (obj ? objGetName(obj) : "{RNOTHING{c"));
+    sprintf(buf, "purge %s", (obj ? protoGetKey(obj) : "{RNOTHING{c"));
     break;
   case RESET_OPEN:
     sprintf(buf, "open/unlock dir %s or container", arg);
@@ -103,14 +150,14 @@
 }
 
 int write_reset_buf(RESET_DATA *reset, char *buf, int buflen, int indent,
-		    bool indent_first) {
-  int i = 0;
+		    bool indent_first, const char *locale) {
+  int  i = 0;
 
   if(indent_first)
     i += indent_line(buf, buflen, indent);
   i += snprintf(buf+i, buflen-i,
 		"{c%s with {w%d%% {cchance {w%d {ctime%s (max {w%d{c, rm. {w%d{c)\r\n",
-		write_reset_arg(resetGetType(reset), resetGetArg(reset)),
+		write_reset_arg(resetGetType(reset),resetGetArg(reset), locale),
 		resetGetChance(reset),
 		resetGetTimes(reset),
 		(resetGetTimes(reset) == 1 ? "" : "s"),
@@ -124,7 +171,7 @@
     LIST_ITERATOR *list_i = newListIterator(resetGetOn(reset));
     RESET_DATA     *next  = NULL;
     ITERATE_LIST(next, list_i)
-      i += write_reset_buf(next, buf+i, buflen-i, indent+2, TRUE);
+      i += write_reset_buf(next, buf+i, buflen-i, indent+2, TRUE, locale);
     deleteListIterator(list_i);
   }
 
@@ -135,7 +182,7 @@
     LIST_ITERATOR *list_i = newListIterator(resetGetIn(reset));
     RESET_DATA     *next  = NULL;
     ITERATE_LIST(next, list_i)
-      i += write_reset_buf(next, buf+i, buflen-i, indent+2, TRUE);
+      i += write_reset_buf(next, buf+i, buflen-i, indent+2, TRUE, locale);
     deleteListIterator(list_i);
   }
 
@@ -146,15 +193,16 @@
     LIST_ITERATOR *list_i = newListIterator(resetGetThen(reset));
     RESET_DATA     *next  = NULL;
     ITERATE_LIST(next, list_i)
-      i += write_reset_buf(next, buf+i, buflen-i, indent+2, TRUE);
+      i += write_reset_buf(next, buf+i, buflen-i, indent+2, TRUE, locale);
     deleteListIterator(list_i);
   }
   return i;
 }
 
-const char *write_reset(RESET_DATA *reset, int indent, bool indent_first) {
+const char *write_reset(RESET_DATA *reset, int indent, bool indent_first,
+			const char *locale) {
   static char buf[MAX_BUFFER];
-  write_reset_buf(reset, buf, MAX_BUFFER, indent, indent_first);
+  write_reset_buf(reset, buf, MAX_BUFFER, indent, indent_first, locale);
   return buf;
 }
 
@@ -163,6 +211,14 @@
 //*****************************************************************************
 // room reset editing
 //*****************************************************************************
+
+// the resedit olc needs these declared
+void    reslistedit_menu(SOCKET_DATA *sock, RESLIST_OLC *data);
+int  reslistedit_chooser(SOCKET_DATA *sock, RESLIST_OLC *data, 
+			 const char *option);
+bool  reslistedit_parser(SOCKET_DATA *sock, RESLIST_OLC *data, int choice, 
+			 const char *arg);
+
 #define RESEDIT_TYPE       1
 #define RESEDIT_TIMES      2
 #define RESEDIT_CHANCE     3
@@ -170,7 +226,7 @@
 #define RESEDIT_ROOM_MAX   5
 #define RESEDIT_ARGUMENT   6
 
-void resedit_menu(SOCKET_DATA *sock, RESET_DATA *data) {
+void resedit_menu(SOCKET_DATA *sock, RESET_OLC *data) {
   send_to_socket(sock,
 		 "{g1) Type:       {c%s\r\n"
 		 "{g2) Times:      {c%d\r\n"
@@ -183,17 +239,17 @@
 		 "{g9) Success menu\r\n"
 		 "---------------------------------------------------------\r\n"
 		 "%s",
-		 resetTypeGetName(resetGetType(data)),
-		 resetGetTimes(data),
-		 resetGetChance(data),
-		 resetGetMax(data),
-		 resetGetRoomMax(data),
-		 resetGetArg(data),
-		 write_reset(data, 0, FALSE)
+		 resetTypeGetName(resetGetType(data->reset)),
+		 resetGetTimes(data->reset),
+		 resetGetChance(data->reset),
+		 resetGetMax(data->reset),
+		 resetGetRoomMax(data->reset),
+		 resetGetArg(data->reset),
+		 write_reset(data->reset, 0, FALSE, data->locale)
 		 );
 }
 
-int resedit_chooser(SOCKET_DATA *sock, RESET_DATA *data, const char *option) {
+int resedit_chooser(SOCKET_DATA *sock, RESET_OLC *data, const char *option) {
   switch(toupper(*option)) {
   case '1':
     olc_display_table(sock, resetTypeGetName, NUM_RESETS, 1);
@@ -212,38 +268,41 @@
     text_to_buffer(sock, "What is the max that can exit in room (0 = no limit): ");
     return RESEDIT_ROOM_MAX;
   case '6':
-    text_to_buffer(sock, "What is the reset argument (i.e. obj vnum, direction, etc...): ");
+    text_to_buffer(sock, "What is the reset argument (i.e. obj name, direction, etc...): ");
     return RESEDIT_ARGUMENT;
   case '7':
-    do_olc(sock, rrledit_menu, rrledit_chooser, rrledit_parser, 
-	   NULL, NULL, NULL, NULL, resetGetOn(data));
+    do_olc(sock, reslistedit_menu, reslistedit_chooser, reslistedit_parser, 
+	   NULL, NULL, deleteReslistOLC, NULL, 
+	   newReslistOLC(resetGetOn(data->reset), data->locale));
     return MENU_NOCHOICE;
   case '8':
-    do_olc(sock, rrledit_menu, rrledit_chooser, rrledit_parser, 
-	   NULL, NULL, NULL, NULL, resetGetIn(data));
+    do_olc(sock, reslistedit_menu, reslistedit_chooser, reslistedit_parser, 
+	   NULL, NULL, deleteReslistOLC, NULL, 
+	   newReslistOLC(resetGetIn(data->reset), data->locale));
     return MENU_NOCHOICE;
   case '9':
-    do_olc(sock, rrledit_menu, rrledit_chooser, rrledit_parser, 
-	   NULL, NULL, NULL, NULL, resetGetThen(data));
+    do_olc(sock, reslistedit_menu, reslistedit_chooser, reslistedit_parser, 
+	   NULL, NULL, deleteReslistOLC, NULL, 
+	   newReslistOLC(resetGetThen(data->reset), data->locale));
     return MENU_NOCHOICE;
   default: return MENU_CHOICE_INVALID;
   }
 }
 
-bool resedit_parser(SOCKET_DATA *sock, RESET_DATA *data, int choice, 
+bool resedit_parser(SOCKET_DATA *sock, RESET_OLC *data, int choice, 
 		    const char *arg){
   switch(choice) {
   case RESEDIT_TYPE: {
     int type = atoi(arg);
     if(type < 0 || type >= NUM_RESETS)
       return FALSE;
-    resetSetType(data, type);
+    resetSetType(data->reset, type);
     // set all of the data to defaults
-    resetSetArg(data, "");
-    resetSetChance(data, 100);
-    resetSetMax(data, 0);
-    resetSetRoomMax(data, 0);
-    resetSetTimes(data, 1);
+    resetSetArg(data->reset, "");
+    resetSetChance(data->reset, 100);
+    resetSetMax(data->reset, 0);
+    resetSetRoomMax(data->reset, 0);
+    resetSetTimes(data->reset, 1);
     return TRUE;
   }
 
@@ -251,7 +310,7 @@
     int times = atoi(arg);
     if(times < 1)
       return FALSE;
-    resetSetTimes(data, times);
+    resetSetTimes(data->reset, times);
     return TRUE;
   }
 
@@ -259,7 +318,7 @@
     int chance = atoi(arg);
     if(chance < 1 || chance > 100)
       return FALSE;
-    resetSetChance(data, chance);
+    resetSetChance(data->reset, chance);
     return TRUE;
   }
 
@@ -267,7 +326,7 @@
     int max = atoi(arg);
     if(max < 0)
       return FALSE;
-    resetSetMax(data, max);
+    resetSetMax(data->reset, max);
     return TRUE;
   }
 
@@ -275,12 +334,12 @@
     int rmax = atoi(arg);
     if(rmax < 0)
       return FALSE;
-    resetSetRoomMax(data, rmax);
+    resetSetRoomMax(data->reset, rmax);
     return TRUE;
   }
 
   case RESEDIT_ARGUMENT:
-    resetSetArg(data, arg);
+    resetSetArg(data->reset, arg);
     return TRUE;
 
   default: return FALSE;
@@ -292,22 +351,21 @@
 //*****************************************************************************
 // room reset list editing
 //*****************************************************************************
-#define RRLEDIT_EDIT       1
-#define RRLEDIT_DELETE     2
+#define RESLISTEDIT_EDIT       1
+#define RESLISTEDIT_DELETE     2
 
 
-void rrledit_menu(SOCKET_DATA *sock, LIST *list) {
-  LIST_ITERATOR *res_i = newListIterator(list);
+void reslistedit_menu(SOCKET_DATA *sock, RESLIST_OLC *data) {
+  LIST_ITERATOR *res_i = newListIterator(data->res_list);
   RESET_DATA    *reset = NULL;
-  int count = 0;
+  int            count = 0;
 
-  send_to_socket(sock,
-		 "{wCurrent resets:\r\n");
+  send_to_socket(sock, "{wCurrent resets:\r\n");
   ITERATE_LIST(reset, res_i) {
-    send_to_socket(sock, " {g%2d) %s", count, write_reset(reset, 5, FALSE));
+    send_to_socket(sock, " {g%2d) %s", count, 
+		   write_reset(reset, 5, FALSE, data->locale));
     count++;
-  }
-  deleteListIterator(res_i);
+  } deleteListIterator(res_i);
 
   send_to_socket(sock, "\r\n"
 		 "  {gE) edit entry\r\n"
@@ -316,47 +374,67 @@
 		 );
 }
 
+void rrledit_menu(SOCKET_DATA *sock, RESET_LIST *list) {
+  send_to_socket(sock, "{y[{c%s{y]\r\n", resetListGetKey(list));
+  RESLIST_OLC *olc = newReslistOLC(resetListGetResets(list),
+				   get_key_locale(resetListGetKey(list)));
+  reslistedit_menu(sock, olc);
+  deleteReslistOLC(olc);
+}
 
-int rrledit_chooser(SOCKET_DATA *sock, LIST *list, const char *option) {
+int reslistedit_chooser(SOCKET_DATA *sock, RESLIST_OLC *list, 
+			const char *option) {
   switch(toupper(*option)) {
   case 'N': {
     RESET_DATA *data = newReset();
-    listQueue(list, data);
+    listQueue(list->res_list, data);
     do_olc(sock, resedit_menu, resedit_chooser, resedit_parser, 
-	   NULL, NULL, NULL, NULL, data);
+	   NULL, NULL, deleteResetOLC, NULL, 
+	   newResetOLC(data, list->locale));
     return MENU_NOCHOICE;
   }
   case 'E':
-    if(listSize(list) == 0)
+    if(listSize(list->res_list) == 0)
       return MENU_CHOICE_INVALID;
     text_to_buffer(sock, "Which entry do you want to edit (-1 for none): ");
-    return RRLEDIT_EDIT;
+    return RESLISTEDIT_EDIT;
   case 'D':
     text_to_buffer(sock, "Which entry do you want to delete: ");
-    return RRLEDIT_DELETE;
+    return RESLISTEDIT_DELETE;
   default:
     return MENU_CHOICE_INVALID;
   }
 }
 
+int rrledit_chooser(SOCKET_DATA *sock, RESET_LIST *list, const char *option) {
+  RESLIST_OLC *olc = newReslistOLC(resetListGetResets(list),
+				   get_key_locale(resetListGetKey(list)));
+  int retval = reslistedit_chooser(sock, olc, option);
+  deleteReslistOLC(olc);
+  return retval;
+}
 
-bool rrledit_parser(SOCKET_DATA *sock, LIST *list, int choice, const char *arg){
+bool reslistedit_parser(SOCKET_DATA *sock, RESLIST_OLC *list, int choice, 
+			const char *arg) {
   switch(choice) {
-  case RRLEDIT_EDIT: {
+  case RESLISTEDIT_EDIT: {
     RESET_DATA *reset = NULL;
     if(atoi(arg) == NOTHING)
       return TRUE;
-    if(!isdigit(*arg) || (reset = listGet(list, atoi(arg))) == NULL)
+    if(!isdigit(*arg) || 
+       (reset = listGet(list->res_list, atoi(arg))) == NULL)
       return FALSE;
     do_olc(sock, resedit_menu, resedit_chooser, resedit_parser, 
-	   NULL, NULL, NULL, NULL, reset);
+	   NULL, NULL, deleteResetOLC, NULL, 
+	   newResetOLC(reset, list->locale));
     return TRUE;
   }
-  case RRLEDIT_DELETE: {
+  case RESLISTEDIT_DELETE: {
     RESET_DATA *reset = NULL;
-    if(!isdigit(*arg) || (reset = listGet(list, atoi(arg))) == NULL)
+    if(!isdigit(*arg) || 
+       (reset = listGet(list->res_list, atoi(arg))) == NULL)
       return FALSE;
-    listRemove(list, reset);
+    listRemove(list->res_list, reset);
     deleteReset(reset);
     return TRUE;
   }
@@ -364,6 +442,15 @@
   }
 }
 
+bool rrledit_parser(SOCKET_DATA *sock, RESET_LIST *list, int choice, 
+		    const char *arg) {
+  RESLIST_OLC *olc = newReslistOLC(resetListGetResets(list),
+				   get_key_locale(resetListGetKey(list)));
+  int retval = reslistedit_parser(sock, olc, choice, arg);
+  deleteReslistOLC(olc);
+  return retval;
+}
+
 
 
 //*****************************************************************************
@@ -391,9 +478,9 @@
 		 "{c%s\r\n"
 		 "{g5) Description\r\n"
 		 "{c%s\r\n"
-		 "{g6) Exits to    : {y[{c%6d{y]\r\n"
+		 "{g6) Exits to    : {c%s\r\n"
+		 "{g8) Key         : {c%s\r\n"
 		 "{g7) Closable    : {y[{c%6s{y]\r\n"
-		 "{g8) Key vnum    : {y[{c%6d{y]\r\n"
 		 "{g9) Pick diff   : {y[{c%6d{y]\r\n"
 		 "{g0) Spot diff   : {y[{c%6d{y]\r\n"
 		 "{gO) Opposite dir: {c%s{n\r\n",
@@ -403,8 +490,8 @@
 		 (*exitGetSpecEnter(exit) ? exitGetSpecEnter(exit):"<DEFAULT>"),
 		 exitGetDesc(exit),
 		 exitGetTo(exit),
-		 (exitIsClosable(exit) ? "Yes" : "No" ),
 		 exitGetKey(exit),
+		 (exitIsClosable(exit) ? "Yes" : "No" ),
 		 exitGetPickLev(exit),
 		 exitGetHidden(exit),
 		 (*exitGetOpposite(exit) ? exitGetOpposite(exit) : "<DEFAULT>")
@@ -435,7 +522,7 @@
     exitSetClosable(exit, (exitIsClosable(exit) ? FALSE : TRUE));
     return MENU_NOCHOICE;
   case '8':
-    text_to_buffer(sock, "Enter a new key vnum: ");
+    text_to_buffer(sock, "Enter a new key name: ");
     return EXEDIT_KEY;
   case '9':
     text_to_buffer(sock, "Enter a new lock difficulty: ");
@@ -470,10 +557,10 @@
     exitSetSpecEnter(exit, arg);
     return TRUE;
   case EXEDIT_TO:
-    exitSetTo(exit, MAX(NOWHERE, atoi(arg)));
+    exitSetTo(exit, arg);
     return TRUE;
   case EXEDIT_KEY:
-    exitSetKey(exit, MAX(NOTHING, atoi(arg)));
+    exitSetKey(exit, arg);
     return TRUE;
   case EXEDIT_PICK:
     exitSetPickLev(exit, MAX(0, atoi(arg)));
